ESX = nil

TriggerEvent('esx:getSharedObject', function(obj) ESX = obj end)

_menuPool = NativeUI.CreatePool()
mainMenu = NativeUI.CreateMenu("Staff Menu", "~b~Coded by Lefos")
_menuPool:Add(mainMenu)
_menuPool:MouseControlsEnabled (false);
_menuPool:MouseEdgeEnabled (false);
_menuPool:ControlDisablingEnabled(false);

function FirstItem(menu)
local submenu = _menuPool:AddSubMenu(menu, "~g~Player Options") 
   local heal = NativeUI.CreateItem("~g~Heal", "~g~Heal Yourself")
   heal.Activated = function(sender, item)
        if item == heal then
            SetEntityHealth(PlayerPedId(), 200)
	TriggerEvent('esx_status:set', 'hunger', 1000000)
	TriggerEvent('esx_status:set', 'thirst', 1000000)
            notify("~g~You have been healed!")
        end
   end
   local armour = NativeUI.CreateItem("~b~Full Armour", "~b~Equip Vest")
    submenu.OnItemSelect = function(sender, item, index)
        if item == armour then
            SetPedArmour(PlayerPedId(), 100)
            notify("~b~You now have full armour")
        end
	end
	
	local jail = NativeUI.CreateItem("~r~Send to Jail", "~r~Send Closest Player to Jail")
   jail.Activated = function(sender, item, index)
      if item == jail then
        TriggerEvent("esx-qalle-jail:openJailMenu")
          end
	 end
	 
	 local unjail = NativeUI.CreateItem("~r~Unjail", "~r~Select a jailed player to be unjailed")
   unjail.Activated = function(sender, item, index)
      if item == unjail then
		local elements = {}

		ESX.TriggerServerCallback("esx-qalle-jail:retrieveJailedPlayers", function(playerArray)

			if #playerArray == 0 then
				ESX.ShowNotification("Your jail is empty!")
				return
			end

			for i = 1, #playerArray, 1 do
				table.insert(elements, {label = "Prisoner: " .. playerArray[i].name .. " | Jail Time: " .. playerArray[i].jailTime .. " minutes", value = playerArray[i].identifier })
			end

			ESX.UI.Menu.Open(
				'default', GetCurrentResourceName(), 'jail_unjail_menu',
				{
					title = "Unjail Player",
					align = "bottom-right",
					elements = elements
				},
			function(data2, menu2)

				local action = data2.current.value

				TriggerServerEvent("esx-qalle-jail:unJailPlayer", action)

				menu2.close()

			end, function(data2, menu2)
				menu2.close()
			end)
		end)

	end

end, function(data, menu)
	menu.close()
end	

  local comserv = NativeUI.CreateItem("~g~Community Service", "~g~Send Closest Player to Community Service")
 comserv.Activated = function(sender, item, index)
     if item == comserv then
		SendToCommunityService(GetPlayerServerId(playerId))
         end
   end
submenu:AddItem(heal)
submenu:AddItem(armour)
submenu:AddItem(comserv)
submenu:AddItem(jail)
submenu:AddItem(unjail)
end

function SecondItem(menu)
local othermenu = _menuPool:AddSubMenu(menu, "~b~Vehicle Options") 
   local delveh = NativeUI.CreateItem("~r~Delete Vehicle", "~r~Delete Vehicle While In It")
   delveh.Activated = function(sender, item, index)
		if item == delveh then
			TriggerEvent( "wk:deleteVehicle", false )
           -- notify("~r~The vehicle has been deleted!")
        end
	end

	local vehbreak = NativeUI.CreateItem("~r~Break Vehicle", "~r~Break Vehicle While In It")
vehbreak.Activated = function(sender, item, index)
			if item == vehbreak then
				car = GetVehiclePedIsIn(GetPlayerPed(-1), false)
				SetVehicleEngineHealth(car, 0)
				SetVehicleFuelLevel(car, 0)
				SetVehicleBodyHealth(car, 0)
				notify("~r~Vehicle Broken...")
			end
		end

local repair = NativeUI.CreateItem("~o~Repair & Clean Vehicle", "~o~Repair & Clean Vehicle")
   repair.Activated = function(sender, item, index)
        if item == repair then
            car = GetVehiclePedIsIn(GetPlayerPed(-1), false)
            SetVehicleFixed(car)
			SetVehicleDirtLevel(car, 0)
			SetVehicleWheelHealth(car, -1, 100)
            notify("~o~The vehicle has been repaired and cleaned!")
          end
     end
othermenu:AddItem(repair)
othermenu:AddItem(vehbreak)
othermenu:AddItem(delveh)	
end

FirstItem(mainMenu)
SecondItem(mainMenu)
_menuPool:RefreshIndex()

Citizen.CreateThread(function()
    while true do
        Citizen.Wait(0)
        _menuPool:ProcessMenus()
        --[[ The "F10" button will activate the menu ]]
        if IsControlJustPressed(1, 57) then
            mainMenu:Visible(not mainMenu:Visible())
        end 
    end
end)




--[[ COPY BELOW ]]

function notify(text)
    SetNotificationTextEntry("STRING")
    AddTextComponentString(text)
    DrawNotification(true, true)
end

function dialogMenu(quistionText , maxLenght )
	while true do
		AddTextEntry('quistion', quistionText )
		DisplayOnscreenKeyboard(1, "quistion", "", "" , "", "", "", maxLenght )
		while UpdateOnscreenKeyboard() ~= 1 and UpdateOnscreenKeyboard() ~= 2 do
			Citizen.Wait(7)
		end
		local playerReplay = GetOnscreenKeyboardResult()
		if ( playerReplay ~= nil ) then
			return playerReplay 
		end
	end
end

RegisterNetEvent( "wk:deleteVehicle" )
AddEventHandler( "wk:deleteVehicle", function()
    local ped = GetPlayerPed( -1 )

    if ( DoesEntityExist( ped ) and not IsEntityDead( ped ) ) then 
        local pos = GetEntityCoords( ped )

        if ( IsPedSittingInAnyVehicle( ped ) ) then 
            local vehicle = GetVehiclePedIsIn( ped, false )

            if ( GetPedInVehicleSeat( vehicle, -1 ) == ped ) then 
                DeleteGivenVehicle( vehicle, numRetries )
            else 
                notify( "You must be in the driver's seat!" )
            end 
        else
            local inFrontOfPlayer = GetOffsetFromEntityInWorldCoords( ped, 0.0, distanceToCheck, 0.0 )
            local vehicle = GetVehicleInDirection( ped, pos, inFrontOfPlayer )

            if ( DoesEntityExist( vehicle ) ) then 
                DeleteGivenVehicle( vehicle, numRetries )
            else 
                notify( "~y~You must be in or near a vehicle to delete it." )
            end 
        end 
    end 
end )



function SendToCommunityService()
		local playerId = dialogMenu('Enter Player ID:' , 6 )
		local swipes = dialogMenu('Add Swipes:'  , 6 )
		if playerId == nil then
			ESX.ShowNotification('Invalid ID.')
	    else
		TriggerServerEvent("esx_communityservice:sendToCommunityService", playerId , swipes )
		if swipes == nil then
			ESX.ShowNotification('Invalid services count.')
		else
			TriggerServerEvent("esx_communityservice:sendToCommunityService", playerId , swipes )
end
end
end

function releaseFromCommunityService(target)
	local playerId = dialogMenu('Enter Player ID:' , 6 )
	TriggerClientEvent('esx_communityservice:finishCommunityService', playerId)
end

function DeleteGivenVehicle( veh, timeoutMax )
    local timeout = 0 

    SetEntityAsMissionEntity( veh, true, true )
    DeleteVehicle( veh )

    if ( DoesEntityExist( veh ) ) then
        Notify( "~r~Failed to delete vehicle, trying again..." )

        -- Fallback if the vehicle doesn't get deleted
        while ( DoesEntityExist( veh ) and timeout < timeoutMax ) do 
            DeleteVehicle( veh )

            -- The vehicle has been banished from the face of the Earth!
            if ( not DoesEntityExist( veh ) ) then 
                Notify( "~g~Vehicle deleted." )
            end 

            -- Increase the timeout counter and make the system wait
            timeout = timeout + 1 
            Citizen.Wait( 500 )

            -- We've timed out and the vehicle still hasn't been deleted. 
            if ( DoesEntityExist( veh ) and ( timeout == timeoutMax - 1 ) ) then
                Notify( "~r~Failed to delete vehicle after " .. timeoutMax .. " retries." )
            end 
        end 
    else 
        Notify( "~g~Vehicle deleted." )
    end 
end 

function GetVehicleInDirection( entFrom, coordFrom, coordTo )
	local rayHandle = StartShapeTestCapsule( coordFrom.x, coordFrom.y, coordFrom.z, coordTo.x, coordTo.y, coordTo.z, 5.0, 10, entFrom, 7 )
    local _, _, _, _, vehicle = GetShapeTestResult( rayHandle )
    
    if ( IsEntityAVehicle( vehicle ) ) then 
        return vehicle
    end 
end


AddEventHandler('esx_basicneeds:isEating', function(cb)
	cb(IsAnimated)
end)

RegisterNetEvent('esx_basicneeds:onEat')
AddEventHandler('esx_basicneeds:onEat', function(prop_name)
	if not IsAnimated then
		prop_name = prop_name or 'prop_cs_burger_01'
		IsAnimated = true

		Citizen.CreateThread(function()
			local playerPed = PlayerPedId()
			local x,y,z = table.unpack(GetEntityCoords(playerPed))
			local prop = CreateObject(GetHashKey(prop_name), x, y, z + 0.2, true, true, true)
			local boneIndex = GetPedBoneIndex(playerPed, 18905)
			AttachEntityToEntity(prop, playerPed, boneIndex, 0.12, 0.028, 0.001, 10.0, 175.0, 0.0, true, true, false, true, 1, true)

			ESX.Streaming.RequestAnimDict('mp_player_inteat@burger', function()
				TaskPlayAnim(playerPed, 'mp_player_inteat@burger', 'mp_player_int_eat_burger_fp', 8.0, -8, -1, 49, 0, 0, 0, 0)

				Citizen.Wait(3000)
				IsAnimated = false
				ClearPedSecondaryTask(playerPed)
				DeleteObject(prop)
			end)
		end)

	end
end)

RegisterNetEvent('esx_basicneeds:onDrink')
AddEventHandler('esx_basicneeds:onDrink', function(prop_name)
	if not IsAnimated then
		prop_name = prop_name or 'prop_ld_flow_bottle'
		IsAnimated = true

		Citizen.CreateThread(function()
			local playerPed = PlayerPedId()
			local x,y,z = table.unpack(GetEntityCoords(playerPed))
			local prop = CreateObject(GetHashKey(prop_name), x, y, z + 0.2, true, true, true)
			local boneIndex = GetPedBoneIndex(playerPed, 18905)
			AttachEntityToEntity(prop, playerPed, boneIndex, 0.12, 0.028, 0.001, 10.0, 175.0, 0.0, true, true, false, true, 1, true)

			ESX.Streaming.RequestAnimDict('mp_player_intdrink', function()
				TaskPlayAnim(playerPed, 'mp_player_intdrink', 'loop_bottle', 1.0, -1.0, 2000, 0, 1, true, true, true)

				Citizen.Wait(3000)
				IsAnimated = false
				ClearPedSecondaryTask(playerPed)
				DeleteObject(prop)
			end)
		end)

	end
end)